Subject: RE: bug#45125: Subject: 28.0.50; defvar dynamics

From: Drew Adams <[email-masked]>
Date: Wed, 9 Dec 2020 11:55:16 -0800 (PST)

> > Understand that thought as kind of convenience-feature. However,
> > problems for testing and debugging arise from this inconsistency.
> 
> Eval-region and friends still work the same as before.
> 
> If you're doing an `C-x C-e' on a `defvar' form, it doesn't seem like
> it should be surprising that something happens.

What if you do `C-x C-e' on a `let' or a `progn' or
a `when' or a <whatever> that contains a `defvar'?

For acting on a single `defvar' we already had (and
still have) `C-M-x'.  Now we've lost the ability to
use `C-x C-e' on an arbitrary sexp and have its
contained `defvar's be handled as they would be by
`eval-region'.

At the very least, I think this (big) difference
should be prominently called out in the doc (not
just doc strings) - letting users know that, in
effect', `C-x C-e' (now) behaves differently from
`eval-region'.

Some differences in behavior can be handy.  But
quirks can also lead to confusion.  The previous
behavior has existed for decades, and I'm not
aware of any complaints about it.

The case of `defface' is different.  There, the
(longstanding) complaint has been that it is the
outlier (IOW, a complaint _against_ an exception)
when it comes to `C-M-x'.  (And that odd behavior
is all the worse because `C-M-x' on a `defface'
echoes the face name, just as if it actually did
update the face definition.)

Really, these constructs deserved (still deserve?)
a serious general reconsideration, to perhaps
increase consistency and user-friendly behavior.
Instead, it looks like we got a quick reflex to a
request out of the blue - after long longstanding
behavior.

Don't get me wrong.  I'm glad that the question
was at least raised again and finally considered.
I just don't think we're really there yet.